// time.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "time.h"
BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved)
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
	}
    return TRUE;
}

void iGetTimeCommon(SYSTEMTIME* t, char* lcTimeOut16Bytes, int* lnYear, int* lnMonth, int* lnDow, int* lnDay, int* lnHour, int* lnMin, int* lnSec, int* lnMs)
{
	if (lcTimeOut16Bytes)		memcpy(lcTimeOut16Bytes, t, sizeof(*t));
	if (lnYear)					*lnYear		= (int)t->wYear;
	if (lnMonth)				*lnMonth	= (int)t->wMonth;
	if (lnDow)					*lnDow		= (int)t->wDayOfWeek;
	if (lnDay)					*lnDay		= (int)t->wDay;
	if (lnHour)					*lnHour		= (int)t->wHour;
	if (lnMin)					*lnMin		= (int)t->wMinute;
	if (lnSec)					*lnSec		= (int)t->wSecond;
	if (lnMs)					*lnMs		= (int)t->wMilliseconds;
}


extern "C"
{
	TIME_API void time_getLocalTime(char* lcTimeOut16Bytes, int* lnYear, int* lnMonth, int* lnDow, int* lnDay, int* lnHour, int* lnMin, int* lnSec, int* lnMs)
	{
		SYSTEMTIME	now;
		GetLocalTime(&now);
		iGetTimeCommon(&now, lcTimeOut16Bytes, lnYear, lnMonth, lnDow, lnDay, lnHour, lnMin, lnSec, lnMs);
	}

	TIME_API void time_getSystemTime(char* lcTimeOut16Bytes, int* lnYear, int* lnMonth, int* lnDow, int* lnDay, int* lnHour, int* lnMin, int* lnSec, int* lnMs)
	{
		SYSTEMTIME	now;
		GetSystemTime(&now);
		iGetTimeCommon(&now, lcTimeOut16Bytes, lnYear, lnMonth, lnDow, lnDay, lnHour, lnMin, lnSec, lnMs);
	}

	TIME_API double time_getDelta(char* tcTime16Bytes_1, char* tcTime16Bytes_2)
	{
		double		lfDelta;

		union
		{
			__int64		_ft1;
			FILETIME	ft1;
		};

		union
		{
			__int64		_ft2;
			FILETIME	ft2;
		};

		SystemTimeToFileTime((SYSTEMTIME*)tcTime16Bytes_1, &ft1);
		SystemTimeToFileTime((SYSTEMTIME*)tcTime16Bytes_2, &ft2);

		lfDelta = (double)(_ft1 - _ft2) / 10000000.0;
		return lfDelta;
	}

	TIME_API void time_adjustByDelta(char* lcTimeInOut16Bytes, double tfSeconds, int lnYear, int lnMonth, int lnDow, int lnDay, int lnHour, int lnMin, int lnSec, int lnMs)
	{
		union
		{
			__int64		_ft;
			FILETIME	ft;
		};

		SystemTimeToFileTime((SYSTEMTIME*)lcTimeInOut16Bytes, &ft);
		_ft += (__int64)tfSeconds * 10000000;
		FileTimeToSystemTime(&ft, (SYSTEMTIME*)lcTimeInOut16Bytes);
	}
};
